package com.gemstone.android.gbjtest;

import com.gemstone.gbj.*;

public class GSInterface {
	
static GbjSession session = null;

// Initializes GbjGciInterface
public static void initialize( ) {
	// NOTE: we *must* use GbjSession.initialize with the name set to the package name
	// In order for the Android GCI code to find the gbjgci and libssl libraries.
	GbjSession.initialize(false, "com.gemstone.android.gbjtest", 100000, 1000, 1000);
}

// returns " " if login OK, otherwise string describing error
public static String login(String ipAddress, String stoneName, String netldiPort, String userName, String password) {
	
    String result = " ";
    
    if ((session != null) && (session.isLoggedIn())) {
    	return "Session already logged in!";
    }
	
    // Configure GS login parameters
    GbjParameters p = new GbjParameters();
    p.serverName = "!@" + ipAddress + "!" + stoneName;
    p.userName =  userName;
    p.password = password;
    p.gemnetName = "!@" + ipAddress + "#netldi:" + netldiPort + "!gemnetobject";

    // Login the GS session
    session = new GbjSession(p);
    try { 
    	session.connect(); 
    	session.setTransactionMode("autoBegin");
    } catch (Throwable e) {
    	result = "Problem logging into " + p.serverName + ":\n " + e.getMessage( );
    	// e.printStackTrace( );
    }
    return result;
}

public static String execute(String command) {
	if ((session == null) || (!session.isLoggedIn())) {
		return "Session not logged in!";
	} else {
		String result;
		try { result = session.execute(command).printString(); }
        catch (GbjException e) {
        	result = e.getMessage( );
        }
        return result;
	}
}

public static String abort( ) {
	if ((session == null) || (!session.isLoggedIn())) {
		return "Session not logged in!";
	} else {
		session.abortTransaction();
		return "Session aborted!";
	}
}

public static String commit( ) {
	if ((session == null) || (!session.isLoggedIn())) {
		return "Session not logged in!";
	} else if (session.commitTransaction()) {
		return "Session committed!";
	} else {
		return "Commit failed!";
	}
}

public static String logout( ) {
	if ((session == null) || (!session.isLoggedIn())) {
		return "Session not logged in!";
	} else {
		session.logout();
		return "Session logged out!";
	}
}

}
